'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const stylable_1 = require("stylable");
const provider_1 = require("./provider");
function createProvider(stylable, tsLangService, withFilePrefix = true) {
    // const styl = new Stylable('/', createFs(docs, fileSystem, withFilePrefix), () => ({ default: {} }))
    return new provider_1.default(stylable, tsLangService);
}
exports.createProvider = createProvider;
function createFs(fileSystem, withFilePrefix = true) {
    return {
        readFileSync(path) {
            return fileSystem.loadTextFileSync(path).toString();
        },
        statSync(path) {
            return {
                mtime: new Date(Date.now())
            };
        }
    };
}
exports.createFs = createFs;
function createProcessor(fileSystem, withFilePrefix = true) {
    let proccesor = stylable_1.cachedProcessFile((fullpath, content) => {
        return stylable_1.process(stylable_1.safeParse(content, { from: fullpath }));
    }, createFs(fileSystem, withFilePrefix));
    return proccesor;
}
exports.createProcessor = createProcessor;
//# sourceMappingURL=provider-factory.js.map