import { CompletionItem, TextEdit, Location, TextDocument, Range, Position, NotificationType, Command, ParameterInformation, Diagnostic } from 'vscode-languageserver';
import { DocumentColorRequest, ColorPresentationRequest } from 'vscode-languageserver-protocol/lib/protocol.colorProvider.proposed';
import { FileSystemReadSync } from 'kissfs';
import * as ts from 'typescript';
export interface NotificationTypes {
    openDoc: NotificationType<string, void>;
    colorRequest: typeof DocumentColorRequest;
    colorPresentationRequest: typeof ColorPresentationRequest;
}
export interface LSPTypeHelpers {
    CompletionItem: typeof CompletionItem;
    TextEdit: typeof TextEdit;
    Location: typeof Location;
    Range: typeof Range;
    Position: typeof Position;
    Command: typeof Command;
    ParameterInformation: typeof ParameterInformation;
    Diagnostic: typeof Diagnostic;
}
export declare type ExtendedFSReadSync = {
    get(path: string): TextDocument;
    getOpenedFiles(): string[];
} & FileSystemReadSync;
export declare type ExtendedTsLanguageService = {
    setOpenedFiles: (files: string[]) => void;
    ts: ts.LanguageService;
};
